﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Text;
using System.Windows.Forms;

namespace Big5ToGBK
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_DragEnter(object sender, DragEventArgs e)
        {
            e.Effect = e.Data.GetDataPresent(DataFormats.FileDrop) ? DragDropEffects.Copy : DragDropEffects.None;
        }

        private void Form1_DragDrop(object sender, DragEventArgs e)
        {
            try
            {
                var a = e.Data.GetData(DataFormats.FileDrop) as IEnumerable<string>;

                if (a != null)
                {
                    BeginInvoke(new OpenFiles(OpenFile), new Object[] { a });

                    Activate();        // in the case Explorer overlaps this form

                }
            }
            catch (Exception ex)
            {
                Trace.WriteLine("Error in DragDrop function: " + ex.Message);

                // don't show MessageBox here - Explorer is waiting !

            }

        }

        private delegate void OpenFiles(IEnumerable<string> filenames);

        private static void OpenFile(IEnumerable<string> filenames)
        {
            foreach (var filename in filenames)
            {
                ProcessFile(filename);
            }
            MessageBox.Show("转换完成!");
        }

        private static void ProcessFile(string path)
        {

            var bytes = File.ReadAllBytes(path);
            var s = Encoding.GetEncoding("big5").GetString(bytes);
            var fileName = Path.GetFileNameWithoutExtension(path);
            var folder = Path.GetDirectoryName(path);
            var destPath = Path.Combine(folder, fileName + "-简体" + Path.GetExtension(path));
            File.WriteAllBytes(destPath, Encoding.GetEncoding("gbk").GetBytes(s));
        }
    }
}
